\begin{algorithmic}
  \State~$\iterindex \gets 0$
  \Comment{Iteration count}
  \State~$d \gets$ false
  \Comment{Flag if newton step converged or not}
  \While{$\iterindex < \iterindex_{\ms{max}} \, \wedge \, \neg d$}
    \Comment{Start Newton loop}
    \State~$\iterstep \gets \inv{ \jacobian{\vect{f}} \of{ \itervar_{\iterindex} } } \, \vect{f} \of{ \itervar_{\iterindex} }$
    \Comment{Calculate step size}
    \State~$\alpha \gets 1$
    \Comment{Init damping factor}
    \State~$c \gets$ false
    \Comment{Flag if damped newton converged}
    \While{$ \alpha >= \nicefrac{1}{1024} \, \wedge \, \neg c$}
      \Comment{Start damped Newton loop}
      \State~$ \tilde{ \itervar }_{\iterindex + 1} \gets \itervar_{\iterindex} - \alpha \, \iterstep$
      \Comment{Trial update}
      \If{$ \norm{ \vect{f} \of{ \tilde{ \itervar }_{\iterindex + 1} } } \leq \norm{ \vect{f} \of{ \itervar_{\iterindex} } }~$}
        \Comment{Decrease in residual}
        \State~$\itervar_{\iterindex + 1} \gets \tilde{ \itervar }_{\iterindex + 1}$
        \State~$c \gets$ true
      \Else
        \State~$\alpha \gets \alpha / 2$
        \Comment{Residual not smaller, decrease step size}
      \EndIf
    \EndWhile
    \Comment{End damped Newton loop}
    \If{$ \norm{\alpha \, \iterstep} \leq \threshold_{\Delta} \, \wedge \, \norm{\vect{f} \of{\itervar_{\iterindex + 1}}} \leq \threshold_{\ms{res}}$}
      \Comment{Termination checks}
      \State~$d \gets$ true
    \Else
      \State~$\itervar_{\iterindex} = \itervar_{\iterindex + 1}$
    \EndIf
    \State~$\iterindex \gets \iterindex + 1$
    \Comment{Update iteration counter}
  \EndWhile
  \Comment{Outer Newton loop}
\end{algorithmic}
